AlertDescription (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.crypto.tls

## Class AlertDescription

- java.lang.Object
- - org.bouncycastle.crypto.tls.AlertDescription

-     public class AlertDescription
      extends java.lang.Object

  RFC 5246 7.2.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static short` | `access_denied` A valid certificate was received, but when access control was applied, the sender decided not to proceed with negotiation.
    `static short` | `bad_certificate` A certificate was corrupt, contained signatures that did not verify correctly, etc.
    `static short` | `bad_certificate_hash_value` This alert is sent by servers when a certificate hash does not match a client provided certificate_hash.
    `static short` | `bad_certificate_status_response` This alert is sent by clients that receive an invalid certificate status response (see Section 3.6).
    `static short` | `bad_record_mac` This alert is returned if a record is received with an incorrect MAC.
    `static short` | `certificate_expired` A certificate has expired or is not currently valid.
    `static short` | `certificate_revoked` A certificate was revoked by its signer.
    `static short` | `certificate_unknown` Some other (unspecified) issue arose in processing the certificate, rendering it unacceptable.
    `static short` | `certificate_unobtainable` This alert is sent by servers who are unable to retrieve a certificate chain from the URL supplied by the client (see Section 3.3).
    `static short` | `close_notify` This message notifies the recipient that the sender will not send any more messages on this connection.
    `static short` | `decode_error` A message could not be decoded because some field was out of the specified range or the length of the message was incorrect.
    `static short` | `decompression_failure` The decompression function received improper input (e.g., data that would expand to excessive length).
    `static short` | `decrypt_error` A handshake cryptographic operation failed, including being unable to correctly verify a signature or validate a Finished message.
    `static short` | `decryption_failed` This alert was used in some earlier versions of TLS, and may have permitted certain attacks against the CBC mode [CBCATT].
    `static short` | `export_restriction` This alert was used in some earlier versions of TLS.
    `static short` | `handshake_failure` Reception of a handshake_failure alert message indicates that the sender was unable to negotiate an acceptable set of security parameters given the options available.
    `static short` | `illegal_parameter` A field in the handshake was out of range or inconsistent with other fields.
    `static short` | `inappropriate_fallback` If TLS_FALLBACK_SCSV appears in ClientHello.cipher_suites and the highest protocol version supported by the server is higher than the version indicated in ClientHello.client_version, the server MUST respond with an inappropriate_fallback alert.
    `static short` | `insufficient_security` Returned instead of handshake_failure when a negotiation has failed specifically because the server requires ciphers more secure than those supported by the client.
    `static short` | `internal_error` An internal error unrelated to the peer or the correctness of the protocol (such as a memory allocation failure) makes it impossible to continue.
    `static short` | `no_certificate` This alert was used in SSLv3 but not any version of TLS.
    `static short` | `no_renegotiation` Sent by the client in response to a hello request or by the server in response to a client hello after initial handshaking.
    `static short` | `protocol_version` The protocol version the client has attempted to negotiate is recognized but not supported.
    `static short` | `record_overflow` A TLSCiphertext record was received that had a length more than 2^14+2048 bytes, or a record decrypted to a TLSCompressed record with more than 2^14+1024 bytes.
    `static short` | `unexpected_message` An inappropriate message was received.
    `static short` | `unknown_ca` A valid certificate chain or partial chain was received, but the certificate was not accepted because the CA certificate could not be located or couldn't be matched with a known, trusted CA.
    `static short` | `unknown_psk_identity` If the server does not recognize the PSK identity, it MAY respond with an "unknown_psk_identity" alert message.
    `static short` | `unrecognized_name` This alert is sent by servers that receive a server_name extension request, but do not recognize the server name.
    `static short` | `unsupported_certificate` A certificate was of an unsupported type.
    `static short` | `unsupported_extension` Sent by clients that receive an extended server hello containing an extension that they did not put in the corresponding client hello.
    `static short` | `user_canceled` This handshake is being canceled for some reason unrelated to a protocol failure.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AlertDescription()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.String` | `getName(short alertDescription)`
    `static java.lang.String` | `getText(short alertDescription)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### close_notify

          public static final short close_notify

      This message notifies the recipient that the sender will not send any more messages on this connection. Note that as of TLS 1.1, failure to properly close a connection no longer requires that a session not be resumed. This is a change from TLS 1.0 ("The session becomes unresumable if any connection is terminated without proper close_notify messages with level equal to warning.") to conform with widespread implementation practice.
      See Also:
        Constant Field Values

    - #### unexpected_message

          public static final short unexpected_message

      An inappropriate message was received. This alert is always fatal and should never be observed in communication between proper implementations.
      See Also:
        Constant Field Values

    - #### bad_record_mac

          public static final short bad_record_mac

      This alert is returned if a record is received with an incorrect MAC. This alert also MUST be returned if an alert is sent because a TLSCiphertext decrypted in an invalid way: either it wasn't an even multiple of the block length, or its padding values, when checked, weren't correct. This message is always fatal and should never be observed in communication between proper implementations (except when messages were corrupted in the network).
      See Also:
        Constant Field Values

    - #### decryption_failed

          public static final short decryption_failed

      This alert was used in some earlier versions of TLS, and may have permitted certain attacks against the CBC mode [CBCATT]. It MUST NOT be sent by compliant implementations.
      See Also:
        Constant Field Values

    - #### record_overflow

          public static final short record_overflow

      A TLSCiphertext record was received that had a length more than 2^14+2048 bytes, or a record decrypted to a TLSCompressed record with more than 2^14+1024 bytes. This message is always fatal and should never be observed in communication between proper implementations (except when messages were corrupted in the network).
      See Also:
        Constant Field Values

    - #### decompression_failure

          public static final short decompression_failure

      The decompression function received improper input (e.g., data that would expand to excessive length). This message is always fatal and should never be observed in communication between proper implementations.
      See Also:
        Constant Field Values

    - #### handshake_failure

          public static final short handshake_failure

      Reception of a handshake_failure alert message indicates that the sender was unable to negotiate an acceptable set of security parameters given the options available. This is a fatal error.
      See Also:
        Constant Field Values

    - #### no_certificate

          public static final short no_certificate

      This alert was used in SSLv3 but not any version of TLS. It MUST NOT be sent by compliant implementations.
      See Also:
        Constant Field Values

    - #### bad_certificate

          public static final short bad_certificate

      A certificate was corrupt, contained signatures that did not verify correctly, etc.
      See Also:
        Constant Field Values

    - #### unsupported_certificate

          public static final short unsupported_certificate

      A certificate was of an unsupported type.
      See Also:
        Constant Field Values

    - #### certificate_revoked

          public static final short certificate_revoked

      A certificate was revoked by its signer.
      See Also:
        Constant Field Values

    - #### certificate_expired

          public static final short certificate_expired

      A certificate has expired or is not currently valid.
      See Also:
        Constant Field Values

    - #### certificate_unknown

          public static final short certificate_unknown

      Some other (unspecified) issue arose in processing the certificate, rendering it unacceptable.
      See Also:
        Constant Field Values

    - #### illegal_parameter

          public static final short illegal_parameter

      A field in the handshake was out of range or inconsistent with other fields. This message is always fatal.
      See Also:
        Constant Field Values

    - #### unknown_ca

          public static final short unknown_ca

      A valid certificate chain or partial chain was received, but the certificate was not accepted because the CA certificate could not be located or couldn't be matched with a known, trusted CA. This message is always fatal.
      See Also:
        Constant Field Values

    - #### access_denied

          public static final short access_denied

      A valid certificate was received, but when access control was applied, the sender decided not to proceed with negotiation. This message is always fatal.
      See Also:
        Constant Field Values

    - #### decode_error

          public static final short decode_error

      A message could not be decoded because some field was out of the specified range or the length of the message was incorrect. This message is always fatal and should never be observed in communication between proper implementations (except when messages were corrupted in the network).
      See Also:
        Constant Field Values

    - #### decrypt_error

          public static final short decrypt_error

      A handshake cryptographic operation failed, including being unable to correctly verify a signature or validate a Finished message. This message is always fatal.
      See Also:
        Constant Field Values

    - #### export_restriction

          public static final short export_restriction

      This alert was used in some earlier versions of TLS. It MUST NOT be sent by compliant implementations.
      See Also:
        Constant Field Values

    - #### protocol_version

          public static final short protocol_version

      The protocol version the client has attempted to negotiate is recognized but not supported. (For example, old protocol versions might be avoided for security reasons.) This message is always fatal.
      See Also:
        Constant Field Values

    - #### insufficient_security

          public static final short insufficient_security

      Returned instead of handshake_failure when a negotiation has failed specifically because the server requires ciphers more secure than those supported by the client. This message is always fatal.
      See Also:
        Constant Field Values

    - #### internal_error

          public static final short internal_error

      An internal error unrelated to the peer or the correctness of the protocol (such as a memory allocation failure) makes it impossible to continue. This message is always fatal.
      See Also:
        Constant Field Values

    - #### user_canceled

          public static final short user_canceled

      This handshake is being canceled for some reason unrelated to a protocol failure. If the user cancels an operation after the handshake is complete, just closing the connection by sending a close_notify is more appropriate. This alert should be followed by a close_notify. This message is generally a warning.
      See Also:
        Constant Field Values

    - #### no_renegotiation

          public static final short no_renegotiation

      Sent by the client in response to a hello request or by the server in response to a client hello after initial handshaking. Either of these would normally lead to renegotiation; when that is not appropriate, the recipient should respond with this alert. At that point, the original requester can decide whether to proceed with the connection. One case where this would be appropriate is where a server has spawned a process to satisfy a request; the process might receive security parameters (key length, authentication, etc.) at startup, and it might be difficult to communicate changes to these parameters after that point. This message is always a warning.
      See Also:
        Constant Field Values

    - #### unsupported_extension

          public static final short unsupported_extension

      Sent by clients that receive an extended server hello containing an extension that they did not put in the corresponding client hello. This message is always fatal.
      See Also:
        Constant Field Values

    - #### certificate_unobtainable

          public static final short certificate_unobtainable

      This alert is sent by servers who are unable to retrieve a certificate chain from the URL supplied by the client (see Section 3.3). This message MAY be fatal - for example if client authentication is required by the server for the handshake to continue and the server is unable to retrieve the certificate chain, it may send a fatal alert.
      See Also:
        Constant Field Values

    - #### unrecognized_name

          public static final short unrecognized_name

      This alert is sent by servers that receive a server_name extension request, but do not recognize the server name. This message MAY be fatal.
      See Also:
        Constant Field Values

    - #### bad_certificate_status_response

          public static final short bad_certificate_status_response

      This alert is sent by clients that receive an invalid certificate status response (see Section 3.6). This message is always fatal.
      See Also:
        Constant Field Values

    - #### bad_certificate_hash_value

          public static final short bad_certificate_hash_value

      This alert is sent by servers when a certificate hash does not match a client provided certificate_hash. This message is always fatal.
      See Also:
        Constant Field Values

    - #### unknown_psk_identity

          public static final short unknown_psk_identity

      If the server does not recognize the PSK identity, it MAY respond with an "unknown_psk_identity" alert message.
      See Also:
        Constant Field Values

    - #### inappropriate_fallback

          public static final short inappropriate_fallback

      If TLS_FALLBACK_SCSV appears in ClientHello.cipher_suites and the highest protocol version supported by the server is higher than the version indicated in ClientHello.client_version, the server MUST respond with an inappropriate_fallback alert.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### AlertDescription

          public AlertDescription()

  - ### Method Detail

    - #### getName

          public static java.lang.String getName(short alertDescription)

    - #### getText

          public static java.lang.String getText(short alertDescription)